﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SL.DragDropFriendlyListBox
{
    public class ExtendedListBox:ListBox
    {
        public ClickAction ClickOnSelectedItemAction
        {
            get { return (ClickAction)GetValue(ClickOnSelectedItemActionProperty); }
            set { SetValue(ClickOnSelectedItemActionProperty, value); }
        }

        // Using a DependencyProperty as the backing store for ClickOnSelectedItemAction.  This enables animation, styling, binding, etc...
        public static readonly DependencyProperty ClickOnSelectedItemActionProperty =
            DependencyProperty.Register("ClickOnSelectedItemAction", typeof(ClickAction), typeof(ExtendedListBox), new PropertyMetadata(ClickAction.OverrideSelection));

        //protected override void OnMouseLeftButtonDown(System.Windows.Input.MouseButtonEventArgs e)
        //{
        //    return;
        //    //if (this.ClickOnSelectedItemAction == ClickAction.KeepSelectionIfItemSelected && this)
        //    //  base.OnMouseLeftButtonDown(e);
        //}

        protected override DependencyObject GetContainerForItemOverride()
        {
            //return base.GetContainerForItemOverride();

            ExtendedListBoxItem item = new ExtendedListBoxItem();
            item.ParentListBox = this;

            if (this.ItemContainerStyle != null)
            {
                item.Style = this.ItemContainerStyle;
            }
            return item;

        }
    }

    public enum ClickAction
    {
        KeepSelectionIfItemSelected,
        OverrideSelection
    }
}
